SystemOrganization addCategory: #'Constraints-Tests'!
SystemOrganization addCategory: #'Constraints-Core'!

TestCase subclass: #ConstraintsTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:12'!
testNoException

	self shouldnt: [[1 = 1] alwaysTrue] raise: Exception.! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:32'!
testSimpleAssignmentConstraint

	| ex |
	ex := ExampleClass new.
	[ex a = 42] alwaysTrue.
	self should: [ex a = 42].! !

!ConstraintsTests methodsFor: 'testing' stamp: 'mg 4/15/2014 14:24'!
testUnsatisfiableConstraints

	self should: [[1 = 2] alwaysTrue] raise: Exception.! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:45'!
alwaysTrue
	"This method constructs constraints for all solvable constraints inside this blockClosure."
	| newProcess |
	newProcess := self newTerminatingProcess.
	#ccm withLayerDo: [[newProcess step] doWhileFalse: [newProcess suspendedContext isNil]].
	newProcess terminate.! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:33'!
newTerminatingProcess
	"Answer a Process running the code in the receiver. The process is not 
	scheduled."
	<primitive: 19> "Simulation guard"
	^Process
		forContext: 
			[self value. self terminateProcess.] asContext
		priority: Processor activePriority! !

!BlockClosure methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:33'!
terminateProcess

	^ self! !

Object subclass: #ConstrainedVariable
	instanceVariableNames: 'solverObject val'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Core'!

!ConstrainedVariable methodsFor: 'constraint-construction' stamp: 'mg 4/15/2014 10:48'!
+ aConstraintVariable
	"This method should create a plus constraint from ConstrainedVariables"
	self val: 2358.! !

!ConstrainedVariable methodsFor: 'initialize-release' stamp: 'mg 4/14/2014 11:59'!
initialize

	val := 42.! !

!ConstrainedVariable methodsFor: 'accessing' stamp: 'mg 4/14/2014 11:58'!
solverObject

	^ solverObject! !

!ConstrainedVariable methodsFor: 'accessing' stamp: 'mg 4/14/2014 11:58'!
solverObject: anObject

	solverObject := anObject! !

!ConstrainedVariable methodsFor: 'accessing' stamp: 'mg 4/14/2014 11:59'!
val

	^ val! !

!ConstrainedVariable methodsFor: 'accessing' stamp: 'mg 4/14/2014 11:59'!
val: anObject

	val := anObject! !

Object subclass: #ExampleClass
	instanceVariableNames: 'a b'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Constraints-Tests'!

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
a

	^ a! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
a: anObject

	a := anObject! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
b

	^ b! !

!ExampleClass methodsFor: 'accessing' stamp: 'mg 4/15/2014 14:31'!
b: anObject

	b := anObject! !

!ExampleClass methodsFor: 'initialize-release' stamp: 'mg 4/15/2014 14:33'!
initialize

	a := 1.
	b := 2.! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:28'!
doPrimitive: primitiveIndex method: meth receiver: receiver args: arguments 
	"Simulate a primitive method whose index is primitiveIndex.  The
	 simulated receiver and arguments are given as arguments to this message.
	 If successful, push result and return resuming context, else ^ PrimitiveFailToken.
	 Any primitive which provokes execution needs to be intercepted and simulated
	 to avoid execution running away."
	<layer: #ccm>
	| value cv |
	"Judicious use of primitive 19 (a null primitive that doesn't do anything) prevents
	 the debugger from entering various run-away activities such as spawning a new
	 process, etc.  Injudicious use results in the debugger not being able to debug
	 interesting code, such as the debugger itself.  hence use primtiive 19 with care :-)"
	"SystemNavigation new browseAllSelect: [:m| m primitive = 19]"
	primitiveIndex = 19 ifTrue:
		[ToolSet 
			debugContext: self
			label:'Code simulation error'
			contents: nil].

	"ContextPart>>blockCopy:; simulated to get startpc right"
	(primitiveIndex = 80 and: [(self objectClass: receiver) includesBehavior: ContextPart]) 
		ifTrue: [^self push: ((BlockContext newForMethod: receiver method)
						home: receiver home
						startpc: pc + 2
						nargs: (arguments at: 1))].
	(primitiveIndex = 81 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>value[:value:...]"
		ifTrue: [^receiver pushArgs: arguments from: self].
	(primitiveIndex = 82 and: [(self objectClass: receiver) == BlockContext]) "BlockContext>>valueWithArguments:"
		ifTrue: [^receiver pushArgs: arguments first from: self].
	primitiveIndex = 83 "afr 9/11/1998 19:50" "Object>>perform:[with:...]"
		ifTrue: [^self send: arguments first
					to: receiver
					with: arguments allButFirst
					super: false].
	primitiveIndex = 84 "afr 9/11/1998 19:50 & eem 8/18/2009 17:04" "Object>>perform:withArguments:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: nil].
	primitiveIndex = 100 "eem 8/18/2009 16:57" "Object>>perform:withArguments:inSuperclass:"
		ifTrue: [^self send: arguments first
					to: receiver
					with: (arguments at: 2)
					startClass: (arguments at: 3)].

	"Mutex>>primitiveEnterCriticalSection
	 Mutex>>primitiveTestAndSetOwnershipOfCriticalSection"
	(primitiveIndex = 186 or: [primitiveIndex = 187]) ifTrue:
		[| active effective |
		 active := Processor activeProcess.
		 effective := active effectiveProcess.
		 "active == effective"
		 value := primitiveIndex = 186
					ifTrue: [receiver primitiveEnterCriticalSectionOnBehalfOf: effective]
					ifFalse: [receiver primitiveTestAndSetOwnershipOfCriticalSectionOnBehalfOf: effective].
		 ^((self objectClass: value) == Array
		    and: [value size = 2
		    and: [value first == PrimitiveFailToken]])
			ifTrue: [value]
			ifFalse: [self push: value]].

	primitiveIndex = 188 ifTrue: "eem 5/27/2008 11:10 Object>>withArgs:executeMethod:"
		[^MethodContext
			sender: self
			receiver: receiver
			method: (arguments at: 2)
			arguments: (arguments at: 1)].

	"Closure primitives"
	(primitiveIndex = 200 and: [self == receiver]) ifTrue:
		"ContextPart>>closureCopy:copiedValues:; simulated to get startpc right"
		[^self push: (BlockClosure
						outerContext: receiver
						startpc: pc + 2
						numArgs: arguments first
						copiedValues: arguments last)].
	((primitiveIndex between: 201 and: 205)			 "BlockClosure>>value[:value:...]"
	or: [primitiveIndex between: 221 and: 222]) ifTrue: "BlockClosure>>valueNoContextSwitch[:]"
		[^receiver simulateValueWithArguments: arguments caller: self].
	primitiveIndex = 206 ifTrue:						"BlockClosure>>valueWithArguments:"
		[^receiver simulateValueWithArguments: arguments first caller: self].

	primitiveIndex = 118 ifTrue: "tryPrimitive:withArgs:; avoid recursing in the VM"
		[(arguments size = 2
		 and: [arguments first isInteger
		 and: [(self objectClass: arguments last) == Array]]) ifFalse:
			[^ContextPart primitiveFailTokenFor: nil].
		 ^self doPrimitive: arguments first method: meth receiver: receiver args: arguments last].

	value := primitiveIndex = 120 "FFI method"
				ifTrue: [(meth literalAt: 1) tryInvokeWithArguments: arguments]
				ifFalse:
					[primitiveIndex = 117 "named primitives"
						ifTrue: [self tryNamedPrimitiveIn: meth for: receiver withArgs: arguments]
						ifFalse:
							[receiver tryPrimitive: primitiveIndex withArgs: arguments]].
	^((self objectClass: value) == Array
	    and: [value size = 2
	    and: [value first == PrimitiveFailToken]])
		ifTrue: [value]
		ifFalse: [meth isReturnField 
					ifTrue: [Transcript show: 'found instVarAccesor of instance '; show: receiver; cr.
						cv := ConstrainedVariable new val: value.
						self push: cv]
					ifFalse: [self push: value]]! !

!ContextPart methodsFor: '*Constraints' stamp: 'mg 4/15/2014 13:24'!
send: selector super: superFlag numArgs: numArgs
	"Simulate the action of bytecodes that send a message with selector, 
	selector. The argument, superFlag, tells whether the receiver of the 
	message was specified with 'super' in the source method. The arguments 
	of the message are found in the top numArgs locations on the stack and 
	the receiver just below them."
	<layer: #ccm>
	| receiver arguments |
	Transcript show: 'layer method send '; show: selector; cr.
	arguments := Array new: numArgs.
	numArgs to: 1 by: -1 do: [ :i | arguments at: i put: self pop].
	receiver := self pop.
	selector = '+' 
		ifTrue: [Transcript 
			show: 'send + aruments: '; show: arguments; 
			show: ' receiver: '; show: receiver; 
			cr].
	selector = 'terminateProcess' 
		ifTrue: [Transcript show: 'process is terminating'; cr. ^ nil].
	QuickStep == self ifTrue:
		[QuickStep := nil.
		^self quickSend: selector to: receiver with: arguments super: superFlag].
	^self send: selector to: receiver with: arguments super: superFlag! !
